OpenCL C++ Bindings

Loading...
Searching...
No Matches
cl::Image3DGL Class Reference

Class interface for GL 3D Image Memory objects. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Image3DGL:

## Public Member Functions
| Image3DGL (const Context &context, cl_mem_flags flags, cl_GLenum target, cl_GLint miplevel, cl_GLuint texobj, cl_int *err=nullptr)
| Constructs an Image3DGL in a specified context, from a given GL Texture.
| Image3DGL ()
| Default constructor - initializes to nullptr.
| Image3DGL (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image3DGL & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Public Member Functions inherited from cl::Image3D
| Image3D (const Context &context, cl_mem_flags flags, ImageFormat format, size_type width, size_type height, size_type depth, size_type row_pitch=0, size_type slice_pitch=0, void *host_ptr=nullptr, cl_int *err=nullptr)
| Constructs a 3D Image in a specified context.
| Image3D (const Context &context, const vector< cl_mem_properties > &properties, cl_mem_flags flags, ImageFormat format, size_type width, size_type height, size_type depth, size_type row_pitch=0, size_type slice_pitch=0, void *host_ptr=nullptr, cl_int *err=nullptr)
| Constructs a Image3D with specified properties.
| Image3D ()
| Default constructor - initializes to nullptr.
| Image3D (const cl_mem &image3D, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image3D & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Public Member Functions inherited from cl::Image
template<typename T>
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo().
template<cl_image_info name>
detail::param_traits< detail::cl_image_info, name >::param_type | getImageInfo (cl_int *err=nullptr) const
| Wrapper for clGetImageInfo() that returns by value.
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to nullptr.
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership.
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership.
template<typename T>
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=nullptr)
| Registers a callback function to be called when the memory object is no longer needed.
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
const cl_type & | operator() () const
cl_type | get () const

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::Image
| Image ()
| Default constructor - initializes to nullptr.
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Class interface for GL 3D Image Memory objects.

This is provided to facilitate interoperability with OpenGL.

See Memory for details about copy semantics, etc.

See also
  Memory

Definition at line 5774 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Image3DGL() [1/3]

cl::Image3DGL::Image3DGL | ( | const Context & | context,
|  | cl_mem_flags | flags,
|  | cl_GLenum | target,
|  | cl_GLint | miplevel,
|  | cl_GLuint | texobj,
|  | cl_int * | err = nullptr )
| inline

Constructs an Image3DGL in a specified context, from a given GL Texture.

Wraps clCreateFromGLTexture3D().

Definition at line 5782 of file opencl.hpp.

## ◆ Image3DGL() [2/3]

cl::Image3DGL::Image3DGL | ( |  | ) |
| inline

Default constructor - initializes to nullptr.

Definition at line 5806 of file opencl.hpp.

## ◆ Image3DGL() [3/3]

cl::Image3DGL::Image3DGL | ( | const cl_mem & | image,
|  | bool | retainObject = false )
| inline explicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

Definition at line 5815 of file opencl.hpp.

## Member Function Documentation

## ◆ operator=()

Image3DGL & cl::Image3DGL::operator= | ( | const cl_mem & | rhs | ) |
| inline

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Definition at line 5822 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp